package demo.areacharts ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYStepAreaRendererDemo1 extends JPanel {

  public XYStepAreaRendererDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createXYStackedStepAreaChart("XYStepAreaRenderer Demo 1", "X", "Y",
                                                              dataset, ChartOrientation.VERTICAL,
                                                              true, true, false, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setDomainGridlinePaint(Color.white) ;
    xyplot.setValueGridlinePaint(Color.white) ;
    xyplot.getRender().setBackgroundPaint(Color.lightGray) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;

    dataset.addRowData() ;
    dataset.addData(0, new XYNumberChartData(1.0D, 3D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 4D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 2D)) ;
    dataset.addData(0, new XYNumberChartData(6D, 3D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new XYNumberChartData(1.0D, 7D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 6D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 9D)) ;
    dataset.addData(1, new XYNumberChartData(4D, 5D)) ;
    dataset.addData(1, new XYNumberChartData(6D, 4D)) ;

    return dataset ;
  }

}
