package demo.combinecharts ;

import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.Font ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.IntervalXNumberYBaseValueAxis ;
import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.DateTickUnitType ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.XYValueAxisType ;
import com.ijchart.xychart.data.IntervalXNumberYBaseChartData ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.plot.combine.CombineValueAxisXYPlot ;
import com.ijchart.xychart.render.xy.IntervalXNumberYBaseBar2DRender ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.DateTickUnit ;
import com.ijchart.xychart.title.LegendTitle ;
import com.ijchart.xychart.title.TextTitle ;
import com.ijchart.xychart.util.DatasetUtil ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class CombinedXYPlotDemo3 extends JPanel {
  private Calendar cal = Calendar.getInstance() ;

  private double[][] datasArr = { {2, 1, 2001, 1.5788D}, {3, 1, 2001, 1.5912999999999999D}, {4, 1,
                                2001, 1.5807D}, {5, 1, 2001, 1.5710999999999999D}, {8, 1, 2001,
                                1.5778000000000001D}, {9, 1, 2001, 1.5851D}, {10, 1, 2001, 1.5846D},
                                {11, 1, 2001, 1.5727D}, {12, 1, 2001, 1.5585D}, {15, 1, 2001,
                                1.5693999999999999D}, {16, 1, 2001, 1.5629D}, {17, 1, 2001, 1.5831D},
                                {18, 1, 2001, 1.5624D}, {19, 1, 2001, 1.5693999999999999D}, {22, 1,
                                2001, 1.5615000000000001D}, {23, 1, 2001, 1.5656000000000001D}, {24,
                                1, 2001, 1.5794999999999999D}, {25, 1, 2001, 1.5851999999999999D},
                                {26, 1, 2001, 1.5797000000000001D}, {29, 1, 2001,
                                1.5862000000000001D}, {30, 1, 2001, 1.5803D}, {31, 1, 2001,
                                1.5713999999999999D}, {1, 2, 2001, 1.5717000000000001D}, {2, 2,
                                2001, 1.5734999999999999D}, {5, 2, 2001, 1.5690999999999999D}, {6,
                                2, 2001, 1.5676000000000001D}, {7, 2, 2001, 1.5677000000000001D},
                                {8, 2, 2001, 1.5737000000000001D}, {9, 2, 2001, 1.5653999999999999D},
                                {12, 2, 2001, 1.5621D}, {13, 2, 2001, 1.5761000000000001D}, {14, 2,
                                2001, 1.5898000000000001D}, {15, 2, 2001, 1.6045D}, {16, 2, 2001,
                                1.5851999999999999D}, {19, 2, 2001, 1.5704D}, {20, 2, 2001,
                                1.5891999999999999D}, {21, 2, 2001, 1.5844D}, {22, 2, 2001,
                                1.5933999999999999D}, {23, 2, 2001, 1.5951D}, {26, 2, 2001, 1.5848D},
                                {27, 2, 2001, 1.5706D}, {28, 2, 2001, 1.5680000000000001D}, {1, 3,
                                2001, 1.5645D}, {2, 3, 2001, 1.5753999999999999D}, {5, 3, 2001,
                                1.5808D}, {6, 3, 2001, 1.5766D}, {7, 3, 2001, 1.5755999999999999D},
                                {8, 3, 2001, 1.5760000000000001D}, {9, 3, 2001, 1.5748D}, {12, 3,
                                2001, 1.5779000000000001D}, {13, 3, 2001, 1.5837000000000001D}, {14,
                                3, 2001, 1.5886D}, {15, 3, 2001, 1.5931D}, {16, 3, 2001, 1.5945D},
                                {19, 3, 2001, 1.5880000000000001D}, {20, 3, 2001,
                                1.5817000000000001D}, {21, 3, 2001, 1.5927D}, {22, 3, 2001, 1.6065D},
                                {23, 3, 2001, 1.6006D}, {26, 3, 2001, 1.6007D}, {27, 3, 2001,
                                1.5989D}, {28, 3, 2001, 1.6134999999999999D}, {29, 3, 2001,
                                1.6282000000000001D}, {30, 3, 2001, 1.609D}, {2, 4, 2001, 1.6107D},
                                {3, 4, 2001, 1.6093D}, {4, 4, 2001, 1.5880000000000001D}, {5, 4,
                                2001, 1.5931D}, {6, 4, 2001, 1.5968D}, {9, 4, 2001, 1.6072D}, {10,
                                4, 2001, 1.6167D}, {11, 4, 2001, 1.6214D}, {12, 4, 2001,
                                1.6120000000000001D}, {17, 4, 2001, 1.6229D}, {18, 4, 2001,
                                1.6297999999999999D}, {19, 4, 2001, 1.6158999999999999D}, {20, 4,
                                2001, 1.5995999999999999D}, {23, 4, 2001, 1.6042000000000001D}, {24,
                                4, 2001, 1.6061000000000001D}, {25, 4, 2001, 1.6045D}, {26, 4, 2001,
                                1.597D}, {27, 4, 2001, 1.6094999999999999D}, {30, 4, 2001,
                                1.6141000000000001D}, {1, 5, 2001, 1.6075999999999999D}, {2, 5,
                                2001, 1.6076999999999999D}, {3, 5, 2001, 1.6034999999999999D}, {4,
                                5, 2001, 1.6060000000000001D}, {8, 5, 2001, 1.6177999999999999D},
                                {9, 5, 2001, 1.6083000000000001D}, {10, 5, 2001, 1.6107D}, {11, 5,
                                2001, 1.6209D}, {14, 5, 2001, 1.6228D}, {15, 5, 2001,
                                1.6184000000000001D}, {16, 5, 2001, 1.6167D}, {17, 5, 2001,
                                1.6223000000000001D}, {18, 5, 2001, 1.6305000000000001D}, {21, 5,
                                2001, 1.6419999999999999D}, {22, 5, 2001, 1.6484000000000001D}, {23,
                                5, 2001, 1.6547000000000001D}, {24, 5, 2001, 1.6444000000000001D},
                                {25, 5, 2001, 1.6577D}, {29, 5, 2001, 1.6606000000000001D}, {30, 5,
                                2001, 1.6604000000000001D}, {31, 5, 2001, 1.6772D}, {1, 6, 2001,
                                1.6717D}, {4, 6, 2001, 1.6685000000000001D}, {5, 6, 2001,
                                1.6620999999999999D}, {6, 6, 2001, 1.6459999999999999D}, {7, 6,
                                2001, 1.6333D}, {8, 6, 2001, 1.6265000000000001D}, {11, 6, 2001,
                                1.6311D}, {12, 6, 2001, 1.6237999999999999D}, {13, 6, 2001,
                                1.6299999999999999D}, {14, 6, 2001, 1.6289D}, {15, 6, 2001,
                                1.6275999999999999D}, {18, 6, 2001, 1.6298999999999999D}, {19, 6,
                                2001, 1.6353D}, {20, 6, 2001, 1.6377999999999999D}, {21, 6, 2001,
                                1.6567000000000001D}, {22, 6, 2001, 1.6523000000000001D}, {25, 6,
                                2001, 1.6417999999999999D}, {26, 6, 2001, 1.6429D}, {27, 6, 2001,
                                1.6438999999999999D}, {28, 6, 2001, 1.6605000000000001D}, {29, 6,
                                2001, 1.6598999999999999D}, {2, 7, 2001, 1.6727000000000001D}, {3,
                                7, 2001, 1.6619999999999999D}, {4, 7, 2001, 1.6628000000000001D},
                                {5, 7, 2001, 1.673D}, {6, 7, 2001, 1.6649D}, {9, 7, 2001,
                                1.6603000000000001D}, {10, 7, 2001, 1.6489D}, {11, 7, 2001,
                                1.6420999999999999D}, {12, 7, 2001, 1.6497999999999999D}, {13, 7,
                                2001, 1.6447000000000001D}, {16, 7, 2001, 1.6373D}, {17, 7, 2001,
                                1.6443000000000001D}, {18, 7, 2001, 1.6246D}, {19, 7, 2001,
                                1.6294999999999999D}, {20, 7, 2001, 1.6362000000000001D}, {23, 7,
                                2001, 1.6348D}, {24, 7, 2001, 1.6242000000000001D}, {25, 7, 2001,
                                1.6241000000000001D}, {26, 7, 2001, 1.6281000000000001D}, {27, 7,
                                2001, 1.6295999999999999D}, {30, 7, 2001, 1.6278999999999999D}, {31,
                                7, 2001, 1.6299999999999999D}, {1, 8, 2001, 1.629D}, {2, 8, 2001,
                                1.6236999999999999D}, {3, 8, 2001, 1.6137999999999999D}, {6, 8,
                                2001, 1.6121000000000001D}, {7, 8, 2001, 1.617D}, {8, 8, 2001,
                                1.6134999999999999D}, {9, 8, 2001, 1.5995999999999999D}, {10, 8,
                                2001, 1.5931D}, {13, 8, 2001, 1.5828D}, {14, 8, 2001, 1.5824D}, {15,
                                8, 2001, 1.5783D}, {16, 8, 2001, 1.581D}, {17, 8, 2001,
                                1.5761000000000001D}, {20, 8, 2001, 1.5831D}, {21, 8, 2001, 1.587D},
                                {22, 8, 2001, 1.5808D}, {23, 8, 2001, 1.5845D}, {24, 8, 2001,
                                1.5844D}, {28, 8, 2001, 1.5924D}, {29, 8, 2001, 1.595D}, {30, 8,
                                2001, 1.5941000000000001D}, {31, 8, 2001, 1.5968D}, {3, 9, 2001,
                                1.6020000000000001D}, {4, 9, 2001, 1.6235999999999999D}, {5, 9,
                                2001, 1.6352D}, {6, 9, 2001, 1.6302000000000001D}, {7, 9, 2001,
                                1.6180000000000001D}, {10, 9, 2001, 1.6217999999999999D}, {11, 9,
                                2001, 1.6182000000000001D}, {12, 9, 2001, 1.6156999999999999D}, {13,
                                9, 2001, 1.6171D}, {14, 9, 2001, 1.5960000000000001D}, {17, 9, 2001,
                                1.5952D}, {18, 9, 2001, 1.5863D}, {19, 9, 2001, 1.579D}, {20, 9,
                                2001, 1.5810999999999999D}, {21, 9, 2001, 1.5916999999999999D}, {24,
                                9, 2001, 1.6005D}, {25, 9, 2001, 1.5914999999999999D}, {26, 9, 2001,
                                1.6012D}, {27, 9, 2001, 1.6032D}, {28, 9, 2001, 1.6133D}, {1, 10,
                                2001, 1.6147D}, {2, 10, 2001, 1.6002000000000001D}, {3, 10, 2001,
                                1.6041000000000001D}, {4, 10, 2001, 1.6172D}, {5, 10, 2001,
                                1.6121000000000001D}, {8, 10, 2001, 1.6044D}, {9, 10, 2001,
                                1.5973999999999999D}, {10, 10, 2001, 1.5914999999999999D}, {11, 10,
                                2001, 1.6022000000000001D}, {12, 10, 2001, 1.6013999999999999D},
                                {15, 10, 2001, 1.5942000000000001D}, {16, 10, 2001, 1.5925D}, {17,
                                10, 2001, 1.6007D}, {18, 10, 2001, 1.6000000000000001D}, {19, 10,
                                2001, 1.603D}, {22, 10, 2001, 1.6013999999999999D}, {23, 10, 2001,
                                1.5994999999999999D}, {24, 10, 2001, 1.5951D}, {25, 10, 2001,
                                1.5952999999999999D}, {26, 10, 2001, 1.6056999999999999D}, {29, 10,
                                2001, 1.6051D}, {30, 10, 2001, 1.6027D}, {31, 10, 2001,
                                1.6144000000000001D}, {1, 11, 2001, 1.6138999999999999D}, {2, 11,
                                2001, 1.6189D}, {5, 11, 2001, 1.6248D}, {6, 11, 2001, 1.6267D}, {7,
                                11, 2001, 1.6281000000000001D}, {8, 11, 2001, 1.631D}, {9, 11, 2001,
                                1.6313D}, {12, 11, 2001, 1.6272D}, {13, 11, 2001,
                                1.6361000000000001D}, {14, 11, 2001, 1.6323000000000001D}, {15, 11,
                                2001, 1.6252D}, {16, 11, 2001, 1.6141000000000001D}, {19, 11, 2001,
                                1.6086D}, {20, 11, 2001, 1.6054999999999999D}, {21, 11, 2001,
                                1.6132D}, {22, 11, 2001, 1.6073999999999999D}, {23, 11, 2001,
                                1.6065D}, {26, 11, 2001, 1.6061000000000001D}, {27, 11, 2001,
                                1.6039000000000001D}, {28, 11, 2001, 1.6069D}, {29, 11, 2001,
                                1.6044D}, {30, 11, 2001, 1.5928D}
  } ;

  public CombinedXYPlotDemo3() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    ChartOrientation orientation = ChartOrientation.VERTICAL ;

    DefaultMatrixDataset dataset1 = createDataset() ;
    XYNumberChartData[] average = DatasetUtil.calculateDateMovingAverageDatas
                                  (dataset1.getRowDatas(0), 30, 30) ;

    DefaultMatrixDataset dataset2 = createDataset() ;
    dataset2.addRowData() ;
    dataset2.addRowKey("EUR/GBP (30 Day MA)") ;
    dataset2.addDatas(1, average) ;

    XYNumberValueAxis xAxis1 = new XYNumberValueAxis("Date1", dataset1,
                                                     XYValueAxisType.XY_VALUE_AXIS_X, true) ;
    XYNumberValueAxis yAxis1 = new XYNumberValueAxis("Value", dataset1,
                                                     XYValueAxisType.XY_VALUE_AXIS_Y, false) ;
    yAxis1.setAxisRangeIncludeZero(false) ;
    xAxis1.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_MONTH)) ;

    XYLineAndShapeRender render1 = new XYLineAndShapeRender(dataset1) ;
    render1.setBaseItemShapeVisible(false) ;
    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis1.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis1.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYPlot plot1 = new XYPlot(xAxis1, yAxis1, render1) ;

    XYNumberValueAxis xAxis2 = new XYNumberValueAxis("Date2", dataset2,
                                                     XYValueAxisType.XY_VALUE_AXIS_X, true) ;
    xAxis2.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_MONTH)) ;
    XYNumberValueAxis yAxis2 = new XYNumberValueAxis("Value", dataset2,
                                                     XYValueAxisType.XY_VALUE_AXIS_Y, false) ;
    yAxis2.setAxisRangeIncludeZero(false) ;

    XYLineAndShapeRender render2 = new XYLineAndShapeRender(dataset2) ;
    render2.setBaseItemShapeVisible(false) ;
    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis2.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis2.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYPlot plot2 = new XYPlot(xAxis2, yAxis2, render2) ;

    DefaultMatrixDataset dataset3 = createDataset2() ;
    IntervalXNumberYBaseValueAxis xAxis3 = new IntervalXNumberYBaseValueAxis("Date3", dataset3,
                                                                             XYValueAxisType.
                                                                             XY_VALUE_AXIS_X, true) ;
    xAxis3.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_MONTH)) ;
    IntervalXNumberYBaseValueAxis yAxis3 = new IntervalXNumberYBaseValueAxis("Value", dataset3,
                                                                             XYValueAxisType.
                                                                             XY_VALUE_AXIS_Y, false) ;
    yAxis3.setAxisRangeIncludeZero(false) ;

    IntervalXNumberYBaseBar2DRender render3 = new IntervalXNumberYBaseBar2DRender(dataset3) ;
    if (orientation.equals(ChartOrientation.HORIZONTAL)) {
      xAxis3.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    } else if (orientation.equals(ChartOrientation.VERTICAL)) {
      yAxis3.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    }

    XYPlot plot3 = new XYPlot(xAxis3, yAxis3, render3) ;

    CombineValueAxisXYPlot combinePlot = new CombineValueAxisXYPlot() ;
    combinePlot.addSubPlot(plot1, 1) ;
    combinePlot.addSubPlot(plot2, 1) ;
    combinePlot.addSubPlot(plot3, 1) ;
    combinePlot.setPlotGap(25) ;

    IJChart chart = new IJChart("Demo Chart", IJChart.DEFAULT_TITLE_FONT, combinePlot, true) ;
    LegendTitle title = chart.getLegendTitle() ;
    title.setBackgroundPaint(Color.WHITE) ;
    title.setFillBackground(true) ;

    TextTitle title1 = new TextTitle("This is a subtitle", new Font("SansSerif", 1, 12)) ;
    chart.addSubtitle(title1) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("EUR/GBP") ;
    dataset.addRowData() ;

    for (int i = 0 ; i < datasArr.length ; i++) {
      double[] arr = datasArr[i] ;
      dataset.addData(0, createXYDayData((int) arr[0], (int) arr[1], (int) arr[2], arr[3])) ;
    }

    return dataset ;
  }

  private DefaultMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("EUR/GBP") ;
    dataset.addRowData() ;

    for (int i = 0 ; i < datasArr.length ; i++) {
      double[] arr = datasArr[i] ;
      dataset.addData(0, createIntervalDayData((int) arr[0], (int) arr[1], (int) arr[2], arr[3])) ;
    }

    return dataset ;
  }

  private IntervalXNumberYBaseChartData createIntervalDayData(int day, int month, int year,
                                                              double value) {
    cal.set(Calendar.YEAR, year) ;
    cal.set(Calendar.MONTH, month - 1) ;
    cal.set(Calendar.DAY_OF_MONTH, day) ;

    long startTime = DateUtil.dateToTimeInMillis(cal.get(Calendar.YEAR),
                                                 cal.get(Calendar.MONTH) + 1, day) ;

    long endTime = startTime + 20 * 60 * 60 * 1000L ;

    return new IntervalXNumberYBaseChartData(startTime, endTime, value) ;
  }

  private static XYNumberChartData createXYDayData(int day, int month, int year, double value) {
    long mills = DateUtil.dateToTimeInMillis(year, month, day) ;
    return new XYNumberChartData(mills, value) ;
  }
}
