package demo.images ;

import java.awt.Color ;
import java.util.Calendar ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.ui.RectangleInsets ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DifferenceChartHotspotTest {

  public IJChart createChart() {
    IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createXYDifferenceChart("Difference Chart Demo 1", "Time",
                                                               "Value", dataset,
                                                               ChartOrientation.VERTICAL, true,
                                                               true, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setDomainCrosshairVisible(true) ;
    xyplot.setValueCrosshairVisible(true) ;
    xyplot.setDomainCrosshairLockedOnData(true) ;
    xyplot.setValueCrosshairLockedOnData(true) ;
    xyplot.setDomainCrosshairVisible(true) ;
    xyplot.setValueCrosshairVisible(true) ;
    xyplot.setForegroundAlpha(0.5F) ;

    xyplot.setDomainGridlinePaint(Color.white) ;
    xyplot.setValueGridlinePaint(Color.white) ;
    xyplot.setAxisOffset(new RectangleInsets(5D, 5D, 5D, 5D)) ;

    XYNumberValueAxis dateaxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    dateaxis.setLowerMargin(0.0D) ;
    dateaxis.setUpperMargin(0.0D) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Random 1") ;
    dataset.addRowKey("Random 2") ;
    dataset.addRowData(2) ;

    Calendar cal = Calendar.getInstance() ;
    cal.set(Calendar.HOUR_OF_DAY, 0) ;
    cal.set(Calendar.MINUTE, 0) ;
    cal.set(Calendar.SECOND, 0) ;
    cal.set(Calendar.MILLISECOND, 0) ;

    double d = 0.0D ;
    double d1 = 0.0D ;
    for (int i = 0 ; i < 200 ; i++) {
      d = (d + Math.random()) - 0.5D ;
      d1 = (d1 + Math.random()) - 0.5D ;

      long time = cal.getTimeInMillis() ;
      dataset.addData(0, new XYNumberChartData(time, d)) ;
      dataset.addData(1, new XYNumberChartData(time, d1)) ;
      cal.add(Calendar.DAY_OF_MONTH, 1) ;
    }

    return dataset ;
  }

}
