package demo.images ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.Category3DPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class Line3DChartHotspotTest {

  public IJChart createChart() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createLine3DChart("Line Chart 3D Demo 1", null, "Class Count",
                                                   dataset, ChartOrientation.VERTICAL, true, true) ;

    Category3DPlot plot = (Category3DPlot) chart.getPlot() ;
    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setAxisRangeIncludeZero(false) ;
    numberaxis.setTickUnit(new LongTickUnit()) ;
    numberaxis.setLowerMargin(0.02) ;
    numberaxis.setUpperMargin(0.02) ;

    return chart ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("S1") ;
    dataset.addRowKey("S2") ;

    dataset.addColKey("C1") ;
    dataset.addColKey("C2") ;
    dataset.addColKey("C3") ;
    dataset.addColKey("C4") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(143.19999999999999D)) ;
    dataset.addData(0, new NumberChartData(120.2D)) ;
    dataset.addData(0, new NumberChartData(135D)) ;
    dataset.addData(0, new NumberChartData(115D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new NumberChartData(98.700000000000003D)) ;
    dataset.addData(1, new NumberChartData(63.200000000000003D)) ;
    dataset.addData(1, new NumberChartData(71.400000000000006D)) ;
    dataset.addData(1, new NumberChartData(55D)) ;

    return dataset ;
  }

}
