package demo.linecharts ;

import java.awt.BorderLayout ;
import java.awt.geom.Rectangle2D ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.shape.IChartShape ;
import com.ijchart.xychart.shape.RectangleTextChartShape ;
import demo.dataset.SampleXYDataset ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LineChartDemo4 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public LineChartDemo4() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = new SampleXYDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Line Chart Demo 4", "X", "Y", dataset,
                                                           orientation, true, true, false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.setDomainZeroBaselineVisible(true) ;
    plot.setValueZeroBaselineVisible(true) ;

    XYLineAndShapeRender render = new XYLineAndShapeRender(dataset) {
      protected IChartShape[] getLegendItemShapes(int legendCount) {
        Rectangle2D rect = new java.awt.geom.Rectangle2D.Double( -4D, -3D, 8D, 6D) ;
        if (legendCount > 0) {
          IChartShape[] shapes = new IChartShape[legendCount] ;
          for (int i = 0 ; i < legendCount ; i++) {
            shapes[i] = new RectangleTextChartShape(rect, null) ;
          }

          return shapes ;
        }
        return null ;
      }
    } ;
    render.setBaseItemShapeVisible(false) ;
    plot.setRender(render) ;

    XYNumberValueAxis domainaxis = (XYNumberValueAxis) plot.getDomainAxis() ;
    domainaxis.setLowerMargin(0.00D) ;
    domainaxis.setUpperMargin(0.00D) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

}
