package demo.linecharts ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.axis.value.SymbolValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LineChartDemo8 extends JPanel {

  private ChartOrientation horizontal = ChartOrientation.VERTICAL ;

  private IMatrixDataset dataset = createDataset1() ;

  public LineChartDemo8() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart(
      "Line Chart Demo 8", "Category", "Count", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setDomainGridlineVisible(false);
    NumberValueAxis valueAxis = (NumberValueAxis) plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.03);
    valueAxis.setUpperMargin(0.03);
    valueAxis.setTickUnit(new LongTickUnit()) ;
    SymbolValueAxis symbolaxis = new SymbolValueAxis("Group", valueAxis, new String[] {
                                                     "A", "B", "C", "D", "E", "F"
    }) ;
    plot.setValueAxis(symbolaxis) ;


    LineAndShapeRender render = (LineAndShapeRender) plot.getRender() ;
    render.setRowItemShapeVisible(0, true) ;
    render.setRowItemShapeVisible(1, false) ;
    render.setRowItemShapeVisible(2, true) ;
    render.setRowItemLineVisible(2, false) ;
    render.setAutoSelectFillPaint(false) ;
    render.setBaseItemFillPaint(Color.white) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    double[][] values = { {0.0D, 2D, 1.0D, 3D, 5D}, {2D, 4D, 4D, 5D, 2D, }, {1.0D, 3D, 5D, 2D, 0.0D}
    } ;
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowKey("Series 3") ;

    dataset.addColKey("Category 1") ;
    dataset.addColKey("Category 2") ;
    dataset.addColKey("Category 3") ;
    dataset.addColKey("Category 4") ;
    dataset.addColKey("Category 5") ;

    dataset.addRowData(3) ;

    for (int i = 0 ; i < 3 ; i++) {
      for (int j = 0 ; j < 5 ; j++) {
        dataset.addData(i, new NumberChartData(values[i][j])) ;
      }
    }

    return dataset ;
  }

}
