package demo.linecharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.value.StatisticalNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.StatisticalChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StatisticalLineChartDemo1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  public StatisticalLineChartDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStaticalLineChart(
      "Statistical Line Chart Demo 1", "Type", "Value", dataset, vertical, true, true) ;
    CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;
    categoryplot.setDomainGridlineVisible(false) ;
    CategoryAxis categoryaxis = categoryplot.getCategoryAxis() ;
    categoryaxis.setUpperMargin(0.0D) ;
    categoryaxis.setLowerMargin(0.0D) ;
    StatisticalNumberValueAxis numberaxis = (StatisticalNumberValueAxis) categoryplot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;
    numberaxis.setAxisRangeIncludeZero(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Column 1") ;
    dataset.addColKey("Column 2") ;
    dataset.addColKey("Column 3") ;
    dataset.addColKey("Column 4") ;

    dataset.addRowKey("Row 1") ;
    dataset.addRowKey("Row 2") ;

    dataset.addRowData(2) ;
    dataset.addData(0, new StatisticalChartData(10D, 2.3999999999999999D)) ;
    dataset.addData(0, new StatisticalChartData(15D, 4.4000000000000004D)) ;
    dataset.addData(0, new StatisticalChartData(13D, 2.1000000000000001D)) ;
    dataset.addData(0, new StatisticalChartData(7D, 1.3D)) ;

    dataset.addData(1, new StatisticalChartData(22D, 2.3999999999999999D)) ;
    dataset.addData(1, new StatisticalChartData(18D, 4.4000000000000004D)) ;
    dataset.addData(1, new StatisticalChartData(28D, 2.1000000000000001D)) ;
    dataset.addData(1, new StatisticalChartData(17D, 1.3D)) ;

    return dataset ;
  }

}
