package demo.others ;

import java.awt.Color ;
import java.awt.GridLayout ;
import java.util.Calendar ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.HighLowRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class HighLowChartPanel3 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  /** A working calendar. */
  private static final Calendar CALENDAR = Calendar.getInstance() ;

  SingleRowDataset dataset = HighLowChartPanel1.createDataset1() ;

  String prefix = "a_" ;

  String suffix = "_b" ;

  public HighLowChartPanel3() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
//   addPanel2() ;
//   addPanel3() ;
//   addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createHighLowAndAverageChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, prefix, suffix, 3, vertical, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IJChart chart = ChartFactory.createHighLowAndAverageChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, prefix, suffix, 3, vertical, true, true) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {
    IJChart chart = ChartFactory.createHighLowAndAverageChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", HighLowChartPanel1.createDataset1(), prefix, suffix, 3, horizontal, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {
    IJChart chart = ChartFactory.createHighLowAndAverageChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", HighLowChartPanel1.createDataset1(), prefix, suffix, 3, horizontal, true, true) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    HighLowRender render2 = (HighLowRender) plot.getRender() ;
    render2.setOpenLinePaint(Color.blue) ;
    render2.setCloseLinePaint(Color.CYAN) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  /**
   * Creates a date.
   *
   * @param yyyy  the year.
   * @param month  the month (1 - 12).
   * @param day  the day.
   * @param hour  the hour.
   * @param min  the minute.
   *
   * @return a date.
   */
  public static synchronized Date createDate(final int yyyy, final int month, final int day,
                                             final int hour, final int min) {

    CALENDAR.clear() ;
    CALENDAR.set(yyyy, month - 1, day, hour, min) ;
    return CALENDAR.getTime() ;
  }

}
