package demo.others.annotationcharts;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.annotation.XYTextAnnotation ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYTextAnnotationTest1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  private IMatrixDataset dataset = createDataset1() ;

  public XYTextAnnotationTest1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;

//    setLayout(new GridLayout(2, 2)) ;
//    addPanel1() ;
//    addPanel2() ;
//    addPanel3() ;
//    addPanel4() ;
  }

  private void addPanel1() {

    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYTextAnnotation annotation1 = new XYTextAnnotation("annotation1", 10D, 1D) ;
    XYTextAnnotation annotation2 = new XYTextAnnotation("annotation2", 70D, 2D) ;
    XYTextAnnotation annotation3 = new XYTextAnnotation("annotation3", 100D, 3D) ;
    XYTextAnnotation annotation4 = new XYTextAnnotation("annotation4", 70D, 7D) ;

    plot.getRender().addAnnotation(annotation1) ;
    plot.getRender().addAnnotation(annotation2) ;
    plot.getRender().addAnnotation(annotation3) ;
    plot.getRender().addAnnotation(annotation4) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("First") ;
    dataset.addRowData() ;
    dataset.addData(0, new XYNumberChartData(10D, 1D)) ;
    dataset.addData(0, new XYNumberChartData(20D, 4D)) ;
    dataset.addData(0, new XYNumberChartData(90D, 15D)) ;
    dataset.addData(0, new XYNumberChartData(40D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(50D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(60D, 7D)) ;
    dataset.addData(0, new XYNumberChartData(70D, 7D)) ;
    dataset.addData(0, new XYNumberChartData(80D, 8D)) ;

    dataset.addRowKey("Second") ;
    dataset.addRowData() ;
    dataset.addData(1, new XYNumberChartData(10D, 5D)) ;
    dataset.addData(1, new XYNumberChartData(20D, 7D)) ;
    dataset.addData(1, new XYNumberChartData(30D, 6D)) ;
    dataset.addData(1, new XYNumberChartData(40D, 8D)) ;
    dataset.addData(1, new XYNumberChartData(50D, 4D)) ;
    dataset.addData(1, new XYNumberChartData(60D, 4D)) ;
    dataset.addData(1, new XYNumberChartData(70D, 2D)) ;
    dataset.addData(1, new XYNumberChartData(80D, 1.0D)) ;

    dataset.addRowKey("Third") ;
    dataset.addRowData() ;
    dataset.addData(2, new XYNumberChartData(30D, 4D)) ;
    dataset.addData(2, new XYNumberChartData(40D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(50D, 2D)) ;
    dataset.addData(2, new XYNumberChartData(60D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(70D, 6D)) ;
    dataset.addData(2, new XYNumberChartData(80D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(90D, 4D)) ;
    dataset.addData(2, new XYNumberChartData(100D, 3D)) ;

    return dataset ;
  }

}
