package demo.others.categorycharts;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.BoxAndWhiskerData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BoxAndWhiskerChartPanel1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public BoxAndWhiskerChartPanel1() {
    setLayout(new GridLayout(2, 2)) ;
//     setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createCategoryBoxAndWhiskerChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createCategoryBoxAndWhiskerChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.getValueAxis().setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createCategoryBoxAndWhiskerChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createCategoryBoxAndWhiskerChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.getValueAxis().setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("123456789011") ;
//    dataset.addRowKey("ab\ncd\nef") ;
//    dataset.addRowKey("abcde") ;

    double[][] values = { {2, 75, 90, 95, 65, 65, 80, 85, 70, 100}, {2, 75, 90, 95, 65, 65, 80, 85,
                        70, 100, 10000}, {5D, 7D, -6D, 8D, 4D, -4D, 2D, 1.0D}, {4D, 3D, 2D, 3D, 6D,
                        3D, 4D, 3D}
    } ;

    dataset.addRowData() ;
    for (int i = 0 ; i < values.length ; i++) {
      dataset.addColKey("Col key " + i) ;
      BoxAndWhiskerData data = new BoxAndWhiskerData() ;
      for (int j = 0 ; j < values[i].length ; j++) {
        data.addValue(new Double(values[i][j])) ;
      }
      dataset.addData(0, data) ;
    }

    return dataset ;
  }

}
