package demo.others.categorycharts;

import java.awt.GridLayout ;
import java.util.Calendar ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.GranttChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class GranttChartPanel8 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public GranttChartPanel8() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;

//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createGranttChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Scheduled") ;
    dataset.addColKey("Actual") ;

    dataset.addRowKey("Write Proposal") ;
    dataset.addRowKey("Obtain Approval") ;
    dataset.addRowKey("Requirements Analysis") ;
    dataset.addRowKey("Design Phase") ;
    dataset.addRowKey("Design Signoff") ;
    dataset.addRowKey("Alpha Implementation") ;
    dataset.addRowKey("Design Review") ;
    dataset.addRowKey("Revised Design Signoff") ;
    dataset.addRowKey("Beta Implementation") ;
    dataset.addRowKey("Testing") ;
    dataset.addRowKey("Final Implementation") ;
    dataset.addRowKey("Signoff") ;

    dataset.addRowData() ;
    dataset.addData(0, new GranttChartData(createDate(1242824783000L), createDate(1292824784003L),
                                           new Double(0.3))) ;
    dataset.addData(0, new GranttChartData(createDate(1242824783038L), createDate(1282824784099L),
                                           new Double(0.23))) ;

    dataset.addRowData() ;
    dataset.addData(1, new GranttChartData(createDate(1242824783023L), createDate(1282824784239L),
                                           new Double(0.23))) ;
    dataset.addData(1, new GranttChartData(createDate(1242824783098L), createDate(1272824784323L),
                                           new Double(0.43))) ;

    dataset.addRowData() ;
    dataset.addData(2, new GranttChartData(createDate(1242824783029L), createDate(1262824784999L),
                                           new Double(0.343))) ;
    dataset.addData(2, new GranttChartData(createDate(1242824783001L), createDate(1252824784333L),
                                           new Double(0.53))) ;

    dataset.addRowData() ;
    dataset.addData(3, new GranttChartData(createDate(1242824783003L), createDate(1262824784023L),
                                           new Double(0.43))) ;
    dataset.addData(3, new GranttChartData(createDate(1242824783022L), createDate(1272824784938L),
                                           new Double(0.73))) ;

    dataset.addRowData() ;
    dataset.addData(4, new GranttChartData(createDate(1242824783000L), createDate(1282824784033L),
                                           new Double(0.43))) ;
    dataset.addData(4, new GranttChartData(createDate(1242824783023L), createDate(1252824784099L),
                                           new Double(0.53))) ;

    dataset.addRowData() ;
    dataset.addData(5, new GranttChartData(createDate(1242824783234L), createDate(1262824784987L),
                                           new Double(0.33))) ;
    dataset.addData(5, new GranttChartData(createDate(1242824783422L), createDate(1272824784921L),
                                           new Double(0.13))) ;

    dataset.addRowData() ;
    dataset.addData(6, new GranttChartData(createDate(1242824783382L), createDate(1282824784498L),
                                           new Double(0.23))) ;
    dataset.addData(6, new GranttChartData(createDate(1242824783111L), createDate(1242824784378L),
                                           new Double(0.3))) ;

    return dataset ;
  }

  private static Date createDate(long millions) {
    Calendar calendar = Calendar.getInstance() ;
    calendar.setTimeInMillis(millions) ;
    Date date1 = calendar.getTime() ;

    return date1 ;
  }
}
