package demo.others.categorycharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class SymbolCategoryLineAndShapeChartPanel3 extends JPanel {

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  private IMatrixDataset dataset = createDataset1() ;

  public SymbolCategoryLineAndShapeChartPanel3() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {

    String[] symbols = new String[] {"A", "B", "C", "D", "E", "F"
                       , "G", "H", "I", "J", "K", "L", "M", "N"
                       , "O", "P", "Q", "R", "S", "T", "U", "V"
                       , "W", "X", "Y", "Z", "a", "b", "c", "d",
                       "e", "f", "g", "h", "i", "j", "k", "l",
                       "m", "n", "o", "p", "q", "r", "s", "t",
                       "u", "v", "w", "x", "y", "z"

    } ;

    IJChart chart = ChartFactory.createSymbolCategoryLineChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, symbols, horizontal, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    double[][] values = { {1, 4, 3, 5, 5, 7, 7, 8}, {5, 7, 6, 8, 4, 4, 2, 1}, {4, 3, 2, 3, 6, 3, 4,
                        3}
    } ;
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("First") ;
    dataset.addRowKey("Second") ;
    dataset.addRowKey("Third") ;

    for (int i = 0 ; i < 3 ; i++) {
      dataset.addRowData() ;
      for (int j = 1 ; j <= 8 ; j++) {
        if (i == 0) {
          dataset.addColKey("Type " + j) ;
        }

        dataset.addData(i, new NumberChartData(values[i][j - 1])) ;
      }
    }

    return dataset ;
  }

}
