package demo.others.categorycharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class WaterfallBarChartPanel3 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public WaterfallBarChartPanel3() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createWaterfallBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.getValueAxis().setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createWaterfallBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.getValueAxis().setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;

  }

  private void addPanel3() {

    IMatrixDataset dataset = createDataset2() ;
    IJChart chart = ChartFactory.createWaterfallBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.getValueAxis().setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IMatrixDataset dataset = createDataset2() ;
    IJChart chart = ChartFactory.createWaterfallBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.getValueAxis().setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowKey("Row1") ;
    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(12)) ;
    dataset.addData(0, new NumberChartData( -3)) ;
    dataset.addData(0, new NumberChartData( -4)) ;
    dataset.addData(0, new NumberChartData( -2)) ;
    dataset.addData(0, new NumberChartData( -8)) ;

    dataset.addColKey("Col key 1") ;
    dataset.addColKey("Col key 2") ;
    dataset.addColKey("Col key 3") ;
    dataset.addColKey("Col key 4") ;
    dataset.addColKey("Col key 5") ;

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowKey("Row1") ;
    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData( -2)) ;
    dataset.addData(0, new NumberChartData(3)) ;
    dataset.addData(0, new NumberChartData(4)) ;
    dataset.addData(0, new NumberChartData( -5)) ;
    dataset.addData(0, new NumberChartData(6)) ;

    dataset.addColKey("Col key 1") ;
    dataset.addColKey("Col key 2") ;
    dataset.addColKey("Col key 3") ;
    dataset.addColKey("Col key 4") ;
    dataset.addColKey("Col key 5") ;

    return dataset ;
  }

}
