package demo.others.shapes ;

import java.awt.BasicStroke ;
import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Ellipse2D ;
import java.awt.geom.Point2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.BorderFactory ;
import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.shape.BoxAndWhiskerChartShape ;
import com.ijchart.xychart.test.SerialTestUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BoxAndWhiskerChartShapePanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public BoxAndWhiskerChartShapePanel() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(2, 3)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
    addPanel5() ;
    addPanel6() ;
    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    Ellipse2D ellipse = new Ellipse2D.Double(105, 80, 20, 15) ;
    final BoxAndWhiskerChartShape shape = new BoxAndWhiskerChartShape(100, 120, 30, 100, 20, 20,
                                                                      ellipse, 85, null, null, null, null, null) ;

//    shape.setRotate(Math.PI / 10) ;
    shape.setBorderStroke(new BasicStroke(1)) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setFillPaint(Color.RED) ;
    shape.setFillShape(true) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        super.paintComponent(g) ;
        setBackground(Color.white) ;
        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 250)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel2() {
    Ellipse2D ellipse = new Ellipse2D.Double(105, 80, 20, 15) ;
    final BoxAndWhiskerChartShape shape = new BoxAndWhiskerChartShape(100, 120, 30, 100, 20, 20,
                                                                      ellipse, 85, null, null, null, null, null) ;

    shape.setRotate(Math.PI / 10) ;
    shape.setBorderStroke(new BasicStroke(1)) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setFillPaint(Color.RED) ;
    shape.setFillShape(true) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 250)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel3() {
    Ellipse2D ellipse = new Ellipse2D.Double(105, 80, 20, 15) ;
    final BoxAndWhiskerChartShape shape = new BoxAndWhiskerChartShape(100, 120, 30, 100, 20, 20,
                                                                      ellipse, 85, null, null, null, null, null) ;

    shape.setRotate( -Math.PI / 10) ;
    shape.setBorderStroke(new BasicStroke(1)) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setFillPaint(Color.RED) ;
    shape.setFillShape(true) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.draw((Graphics2D) g) ;
//          shape.drawSelect((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 250)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel4() {
    Ellipse2D ellipse = new Ellipse2D.Double(105, 80, 20, 15) ;
    final BoxAndWhiskerChartShape shape = new BoxAndWhiskerChartShape(100, 120, 30, 100, 20, 20,
                                                                      ellipse, 85, null, null, null, null, null) ;

    shape.setBorderPaint(Color.RED) ;
    shape.setFillPaint(Color.RED) ;
    shape.setRotate(Math.PI / 8) ;

    BoxAndWhiskerChartShape clone = null ;
    try {
      clone = (BoxAndWhiskerChartShape) shape.clone() ;
    } catch (CloneNotSupportedException ex) {
    }
    SerialTestUtil.serialObject(clone) ;
    final BoxAndWhiskerChartShape seri = (BoxAndWhiskerChartShape) SerialTestUtil.unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        seri.setSelected(true);
        seri.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + seri.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel5() {
    Ellipse2D ellipse = new Ellipse2D.Double(105, 80, 20, 15) ;
    final BoxAndWhiskerChartShape shape = new BoxAndWhiskerChartShape(100, 120, 30, 100, 20, 20,
                                                                      ellipse, 85, Color.yellow, null, null, null, null) ;

    shape.setBorderPaint(Color.RED) ;
    shape.setFillPaint(Color.RED) ;
    shape.setRotate(Math.PI / 8) ;

    BoxAndWhiskerChartShape clone = null ;
    try {
      clone = (BoxAndWhiskerChartShape) shape.clone() ;
    } catch (CloneNotSupportedException ex) {
    }
    SerialTestUtil.serialObject(clone) ;
    final BoxAndWhiskerChartShape seri = (BoxAndWhiskerChartShape) SerialTestUtil.unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        seri.setSelected(true);
        seri.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + seri.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel6() {
    Ellipse2D ellipse = new Ellipse2D.Double(105, 80, 20, 15) ;
    final BoxAndWhiskerChartShape shape = new BoxAndWhiskerChartShape(100, 120, 30, 100, 20, 20,
                                                                      ellipse, 85, Color.yellow, null, null, null, null) ;

    shape.setBorderPaint(Color.RED) ;
    shape.setFillPaint(Color.RED) ;
    shape.setRotate(IAngle.ANGLE_DOWN_90) ;

    BoxAndWhiskerChartShape clone = null ;
    try {
      clone = (BoxAndWhiskerChartShape) shape.clone() ;
    } catch (CloneNotSupportedException ex) {
    }
    SerialTestUtil.serialObject(clone) ;
    final BoxAndWhiskerChartShape seri = (BoxAndWhiskerChartShape) SerialTestUtil.unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        seri.setSelected(true);
        seri.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + seri.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }
}
