package demo.others.shapes;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Point2D ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.shape.GranttChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class GranttChartShapePanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public GranttChartShapePanel() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(1, 3)) ;
    addPanel1() ;
    addPanel2() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    Rectangle2D granttArea = new Rectangle2D.Double(10, 10, 70, 40) ;
    Rectangle2D completeArea = new Rectangle2D.Double(10, 20, 40, 20) ;
    Rectangle2D incompleteArea = new Rectangle2D.Double(50, 20, 30, 20) ;

    final GranttChartShape textShape = new GranttChartShape(granttArea, completeArea,
                                                            incompleteArea) ;
    textShape.setFillPaint(Color.yellow) ;
    textShape.setFillShape(true) ;
    textShape.setText("1234567890abcdefghijklmnopqrstuvwxyz") ;
    textShape.setCompleteAreaPaint(Color.blue) ;
    textShape.setIncompleteAreaPaint(Color.CYAN) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.draw((Graphics2D) g) ;
        textShape.setDrawBorder(true) ;

        Point2D p = textShape.getLockPoint() ;
        g.setColor(Color.red) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

  private void addPanel2() {
    Rectangle2D granttArea = new Rectangle2D.Double(30, 10, 70, 40) ;
    Rectangle2D completeArea = new Rectangle2D.Double(30, 20, 40, 20) ;
    Rectangle2D incompleteArea = new Rectangle2D.Double(70, 20, 30, 20) ;

    final GranttChartShape textShape = new GranttChartShape(granttArea, completeArea,
                                                            incompleteArea) ;
    textShape.setRotate(Math.PI / 6) ;
    textShape.setFillPaint(Color.yellow) ;
    textShape.setFillShape(true) ;
    textShape.setText("1234567890abcdefghijklmnopqrstuvwxyz") ;
    textShape.setCompleteAreaPaint(Color.blue) ;
    textShape.setIncompleteAreaPaint(Color.CYAN) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.draw((Graphics2D) g) ;
        textShape.setDrawBorder(true) ;

        Point2D p = textShape.getLockPoint() ;
        g.setColor(Color.red) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(140, 140)) ;
    add(panel) ;
  }

}
