package demo.others.xy ;

import java.awt.GridLayout ;
import java.awt.Rectangle ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IChartData ;
import com.ijchart.xychart.data.XYZNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.paint.GrayPaintScale ;
import com.ijchart.xychart.render.xy.XYBlockRender ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYBlockChartPanel1 extends JPanel {

  private IMatrixDataset dataset ;

  private double availableWidth = 0 ;

  private double availableHeight = 0 ;

  public XYBlockChartPanel1() {
    Rectangle rect = super.getVisibleRect() ;
    availableWidth = rect.getWidth() / 2 - 5 ;
    availableHeight = rect.getHeight() / 2 - 5 ;

    dataset = createDataset() ;

    setLayout(new GridLayout(2, 2)) ;
    createPanel1() ;
    createPanel2() ;
    createPanel3() ;
    createPanel4() ;
  }

  public void createPanel1() {
    ChartPanel chartpanel = new ChartPanel(createChart1()) ;
    add(chartpanel) ;
  }

  private IJChart createChart1() {
    IJChart chart = ChartFactory.createXYBlockChart(
      "This is a very long title,it has many words and wrap automatically.", "x",
      "y", "Legend", dataset, ChartOrientation.VERTICAL, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    GrayPaintScale graypaintscale = new GrayPaintScale( -2D, 1.0D) ;
    ((XYBlockRender) plot.getRender()).setPaintScale(graypaintscale) ;

    return chart ;
  }

  public void createPanel2() {
    ChartPanel chartpanel = new ChartPanel(createChart2()) ;
    add(chartpanel) ;
  }

  private IJChart createChart2() {
    IJChart chart = ChartFactory.createXYBlockChart(
      "This is a very long title,it has many words and wrap automatically.", "x",
      "y", "Legend", dataset, ChartOrientation.VERTICAL, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    GrayPaintScale graypaintscale = new GrayPaintScale( -2D, 1.0D) ;
    ((XYBlockRender) plot.getRender()).setPaintScale(graypaintscale) ;

    chart.getLegendTitle().setPosition(RectangleEdge.TOP) ;

    return chart ;
  }

  public void createPanel3() {
    ChartPanel chartpanel = new ChartPanel(createChart3()) ;
    add(chartpanel) ;
  }

  private IJChart createChart3() {
    IJChart chart = ChartFactory.createXYBlockChart(
      "This is a very long title,it has many words and wrap automatically.", "x",
      "y", "Legend", dataset, ChartOrientation.VERTICAL, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    GrayPaintScale graypaintscale = new GrayPaintScale( -2D, 1.0D) ;
    ((XYBlockRender) plot.getRender()).setPaintScale(graypaintscale) ;

    chart.getLegendTitle().setPosition(RectangleEdge.LEFT) ;

    return chart ;
  }

  public void createPanel4() {
    ChartPanel chartpanel = new ChartPanel(createChart4()) ;
    add(chartpanel) ;
  }

  private IJChart createChart4() {
    IJChart chart = ChartFactory.createXYBlockChart(
      "This is a very long title,it has many words and wrap automatically.", "x",
      "y", "Legend", dataset, ChartOrientation.VERTICAL, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    GrayPaintScale graypaintscale = new GrayPaintScale( -2D, 1.0D) ;
    ((XYBlockRender) plot.getRender()).setPaintScale(graypaintscale) ;

    chart.getLegendTitle().setPosition(RectangleEdge.RIGHT) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    return new DefaultMatrixDataset() {

      public int getRowCount() {
        return 1 ;
      }

      public int getColumnCount() {
        return 10000 ;
      }

      public IChartData getData(int i, int j) {
        double x = j / 100 - 50 ;
        double y = j - (j / 100) * 100 - 50 ;
        double z = Math.sin(Math.sqrt(x * x + y * y) / 5D) ;

        return new XYZNumberChartData(x, y, z) ;
      }

      public Object getRowKey(int i) {
        return "sin(sqrt(x + y))" ;
      }

    } ;

  }

}
