package demo.piecharts ;

import java.awt.GridLayout ;
import java.awt.event.ActionEvent ;
import java.awt.event.ActionListener ;

import javax.swing.JPanel ;
import javax.swing.Timer ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.Rotation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.PieRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PieChart3DDemo2 extends JPanel {

  private IJChart chart ;

  public PieChart3DDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
    new Rotator().start() ;
  }

  class Rotator extends Timer implements ActionListener {

    private int angle ;

    Rotator() {
      super(100, null) ;
      angle = 270 ;
      addActionListener(this) ;
    }

    public void actionPerformed(ActionEvent actionevent) {
      NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
      PieRender render = (PieRender) plot.getRender() ;
      render.setStartAngle(angle) ;

      angle = angle + 1 ;
      if (angle == 360) {
        angle = 0 ;
      }
    }
  }

  private void addPanel() {
    SingleRowDataset dataset = createDataset() ;
    chart = ChartFactory.createPie3DChart("Pie Chart 3D Demo 2", dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    plot.setForegroundAlpha(0.6F) ;

    PieRender render = (PieRender) plot.getRender() ;
    render.setStartAngle(270D) ;
    render.setCircular(true) ;
    render.setPieRotation(Rotation.ANTICLOCKWISE) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset dataset = new SingleRowDataset() ;

    dataset.addColKey("Java") ;
    dataset.addColKey("Visual Basic") ;
    dataset.addColKey("C/C++") ;
    dataset.addColKey("PHP") ;
    dataset.addColKey("Perl") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(43.200000000000003D)) ;
    dataset.addData(0, new NumberChartData(10D)) ;
    dataset.addData(0, new NumberChartData(17.5D)) ;
    dataset.addData(0, new NumberChartData(32.5D)) ;
    dataset.addData(0, new NumberChartData(12.5D)) ;

    return dataset ;
  }

}
