package demo.stackedbarcharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.StackedNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.AppendFormatter ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.StackedBarRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedBarChartDemo7 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public StackedBarChartDemo7() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedBarChart("Stacked Bar Chart Demo 7", "Category",
                                                       "Value", dataset, orientation, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;

    StackedNumberValueAxis numberaxis = (StackedNumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickValueFormatter(new AppendFormatter(null, "%")) ;

    StackedBarRender render = (StackedBarRender) plot.getRender() ;
    render.setRenderAsPercentages(true) ;
    render.setBaseItemLabelVisible(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Series 1") ;
    dataset.addColKey("Series 2") ;
    dataset.addColKey("Series 3") ;

    dataset.addRowKey("Category 1") ;
    dataset.addRowKey("Category 2") ;
    dataset.addRowKey("Category 3") ;
    dataset.addRowKey("Category 4") ;

    double data[][] = { {32.399999999999999D, 17.800000000000001D, 27.699999999999999D},
                      {43.200000000000003D, 15.6D, 18.300000000000001D}, {23D, 111.3D, 25.5D}, {13D,
                      11.800000000000001D, 29.5D}
    } ;

    dataset.addRowData(4) ;
    for (int i = 0 ; i < data.length ; i++) {
      for (int j = 0 ; j < data[i].length ; j++) {
        dataset.addData(i, new NumberChartData(data[i][j])) ;
      }
    }

    return dataset ;
  }

}
