package demo.timeseriescharts ;

import java.awt.BasicStroke ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.YIntervalValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.YIntervalChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.DeviationRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DeviationRenderDemo1 extends JPanel {

  public DeviationRenderDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createDeviationChart("DeviationRenderer - Demo 1", "X", "Y",
                                                      dataset, ChartOrientation.VERTICAL,
                                                      true, true, false, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    YIntervalValueAxis yAxis = (YIntervalValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;

    DeviationRender render = (DeviationRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;
    render.setRowItemBorderStroke(0, new BasicStroke(3F, 1, 1)) ;
    render.setRowItemBorderStroke(1, new BasicStroke(3F, 1, 1)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowData(2) ;

    double d = 100D ;
    double d1 = 100D ;
    for (int i = 0 ; i <= 100 ; i++) {
      d = (d + Math.random()) - 0.47999999999999998D ;
      double d2 = 0.050000000000000003D * (double) i ;
      dataset.addData(0, new YIntervalChartData(i, d, d - d2, d + d2)) ;
      d1 = (d1 + Math.random()) - 0.5D ;
      double d3 = 0.070000000000000007D * (double) i ;
      dataset.addData(1, new YIntervalChartData(i, d1, d1 - d3, d1 + d3)) ;
    }

    return dataset ;
  }

}
