package demo.timeseriescharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.marker.ValueMarker ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.ui.Layer ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class TimeSeriesDemo2 extends JPanel {

  public TimeSeriesDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Time Series Demo 2", "Time",
                                                           "Value", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;
    yAxis.addValueMarker(Layer.FOREGROUND, new ValueMarker(550)) ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    long time1 = DateUtil.dateToTimeInMillis(2002, 4, 1) ;
    long time2 = DateUtil.dateToTimeInMillis(2002, 7, 1) ;
    xAxis.addValueMarker(Layer.FOREGROUND, new ValueMarker((time1 + time2) / 2)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Quarterly Data") ;
    dataset.addRowData(1) ;

    dataset.addData(0, createData(1, 2001, 500.19999999999999D)) ;
    dataset.addData(0, createData(4, 2001, 694.10000000000002D)) ;
    dataset.addData(0, createData(7, 2001, 734.39999999999998D)) ;
    dataset.addData(0, createData(10, 2001, 453.19999999999999D)) ;
    dataset.addData(0, createData(1, 2002, 500.19999999999999D)) ;
    dataset.addData(0, createData(4, 2002, Double.NaN)) ;
    dataset.addData(0, createData(7, 2002, 734.39999999999998D)) ;
    dataset.addData(0, createData(10, 2002, 453.19999999999999D)) ;

    return dataset ;
  }

  private static XYNumberChartData createData(int month, int year, double value) {
    return new XYNumberChartData(DateUtil.dateToTimeInMillis(year, month), value) ;
  }

}
