package demo.xycharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYLineAndShapeRenderDemo1 extends JPanel {

  public XYLineAndShapeRenderDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = createChart() ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IJChart createChart() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "XYLineAndShapeRender Demo 1", "X", "Y", dataset, ChartOrientation.VERTICAL,
      true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setRowItemLineVisible(0, true) ;
    render.setRowItemShapeVisible(0, false) ;

    render.setRowItemLineVisible(1, false) ;
    render.setRowItemShapeVisible(1, true) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowData() ;
    dataset.addRowKey("Series 1") ;
    dataset.addData(0, new XYNumberChartData(1.0D, 3.2999999999999998D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 4.4000000000000004D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 1.7D)) ;

    dataset.addRowData() ;
    dataset.addRowKey("Series 2") ;
    dataset.addData(1, new XYNumberChartData(1.0D, 7.2999999999999998D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 0.0D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 9.5999999999999996D)) ;
    dataset.addData(1, new XYNumberChartData(4D, 5.5999999999999996D)) ;

    return dataset ;
  }

}
