package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ʾλǾ.</zh>
 * <en>Used to indicate absolute or relative units.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class UnitType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 1972523627881295449L ;

  /**
   * <zh>ֵ.</zh>
   * <en>Absolute.</en>
   */
  public static final UnitType ABSOLUTE = new UnitType("UnitType.ABSOLUTE") ;

  /**
   * <zh>ֵ(ٷֱ).</zh>
   * <en>Relative.</en>
   */
  public static final UnitType RELATIVE = new UnitType("UnitType.RELATIVE") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private UnitType(final String name) {
    this.name = name ;
  }

  /**
   * <zh>toString.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param obj  the other object.
   * @return A boolean.
   */
  public boolean equals(final Object obj) {
    if (obj == this) {
      return true ;
    }
    if (!(obj instanceof UnitType)) {
      return false ;
    }

    UnitType that = (UnitType) obj ;

    return this.name.equals(that.name) ;
  }

  /**
   * <zh>hascodeֵ.</zh>
   * <en>Returns a hash code value for the object.</en>
   *
   * @return hashcode
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }

}
