package com.ijchart.xychart.event ;

import java.io.Serializable ;
import java.util.EventObject ;

import com.ijchart.xychart.marker.AbstractMarker ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>Marker仯¼.</zh>
 * <en>A change event that encapsulates information about a change to a marker.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class MarkerChangeEvent extends EventObject implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 2682399668002746372L ;

  /**
   * <zh>¼marker.</zh>
   * <en>The marker that generated the change event.</en>
   */
  private AbstractMarker marker ;

  /**
   * <zh>һµĶ.</zh>
   * <en>Creates a new instance.</en>
   *
   * @param marker AbstractMarker <zh>¼marker.</zh>
   * <en>The marker that generated the event.</en>
   */
  public MarkerChangeEvent(AbstractMarker marker) {
    super(marker) ;
    this.marker = marker ;
  }

  /**
   * <zh>ز¼marker.</zh>
   * <en>Returns the marker that generated the event.</en>
   *
   * @return The marker that generated the event.
   */
  public AbstractMarker getMarker() {
    return this.marker ;
  }

}
