package com.ijchart.xychart.listener ;

import com.ijchart.xychart.event.ChartMouseEvent ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>{@link IChartMouseListener}ĳʵ.</zh>
 * <en>An abstract adapter class for receiving chart mouse events.</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public abstract class AbstractChartMouseAdapter implements IChartMouseListener {

  /**
   * <zh>chart¼.</zh>
   * <en>Callback method for receiving notification of a mouse click on a chart.</en>
   *
   * @param event ChartMouseEvent <zh>¼.</zh>
   * <en>The event.</en>
   */
  public void chartMouseClicked(ChartMouseEvent event) {}

  /**
   * <zh>chartƶ¼.</zh>
   * <en>Callback method for receiving notification of a mouse movement on a chart.</en>
   *
   * @param event ChartMouseEvent <zh>¼.</zh>
   * <en>The event.</en>
   */
  public void chartMouseMoved(ChartMouseEvent event) {}

  /**
   * <zh>chart갴¼.</zh>
   * <en>Callback method for receiving notification of a mouse pressed on a chart.</en>
   *
   * @param event ChartMouseEvent <zh>¼.</zh>
   * <en>The event.</en>
   */
  public void chartMousePressed(ChartMouseEvent event) {}

  /**
   * <zh>chartͷ¼.</zh>
   * <en>Callback method for receiving notification of a mouse released on a chart.</en>
   *
   * @param event ChartMouseEvent <zh>¼.</zh>
   * <en>The event.</en>
   */
  public void chartMouseReleased(ChartMouseEvent event) {}

  /**
   * <zh>chart¼.</zh>
   * <en>Callback method for receiving notification of a mouse entered on a chart.</en>
   *
   * @param event ChartMouseEvent <zh>¼.</zh>
   * <en>The event.</en>
   */
  public void chartMouseEntered(ChartMouseEvent event) {}

  /**
   * <zh>chart˳¼.</zh>
   * <en>Callback method for receiving notification of a mouse exited on a chart.</en>
   *
   * @param event ChartMouseEvent <zh>¼.</zh>
   * <en>The event.</en>
   */
  public void chartMouseExited(ChartMouseEvent event) {}

}
