package com.ijchart.xychart.tickunit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ڼĿ̶ֵ.</zh>
 * <en>Calculate the tick unit for chart data.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface INumberTickUnit {
  /**
   * <zh>СֵֵݵȷϵĿ̶ֵ.</zh>
   * <en>Calculate the tick unit by minimum value,maximum value and tick unit count.</en>
   *
   * @param minValue double <zh>Сֵ.</zh>
   * <en>The minimum value.</en>
   * @param maxValue double <zh>ֵ.</zh>
   * <en>The maximum value.</en>
   * @param maxCount int <zh>̶ֵ,0.</zh>
   * <en>The maximum count of tick units (must great than 0).</en>
   * @param includeZero boolean <zh>ֵ,Ƿ0ֵ.</zh>
   * <en>A boolean flag indicates whether or not include zero value.</en>
   *
   * @return String[] <zh>̶ֵǿ,ֵС˳,ÿԪض,(Ϊnull).</zh>
   * <en>An array of tick units,the values are sorted ascending.
   * All elements in array is number (never null).</en>
   */
  String[] getTickUnits(double minValue, double maxValue, int maxCount, boolean includeZero) ;
}
