package com.ijchart.xychart.util ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>Ĺ.</zh>
 * <en>Nice static helpers for working with array.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public abstract class ArrayUtil {

  /**
   * <zh>תеԪ.</zh>
   * <en>Reverse the array of elements.</en>
   *
   * @param arr String[] <zh>Ҫ (Ϊnull).</zh>
   * <en>To deal with the array (null permitted).</en>
   *
   * @return String[] <zh>תԪغ.</zh>
   * <en>After the reversal element of the array.</en>
   */
  public static String[] reverseArray(String[] arr) {
    if (arr == null) {
      return null ;
    }

    int len = arr.length ;
    for (int i = 0 ; i < len / 2 ; i++) {
      String tmp = arr[i] ;
      arr[i] = arr[len - i - 1] ;
      arr[len - i - 1] = tmp ;
    }

    return arr ;
  }

  /**
   * <zh>תеԪ.</zh>
   * <en>Reverse the array of elements.</en>
   *
   * @param arr double[] <zh>Ҫ (Ϊnull).</zh>
   * <en>To deal with the array (null permitted).</en>
   *
   * @return double[] <zh>תԪغ.</zh>
   * <en>After the reversal element of the array.</en>
   */
  public static double[] reverseArray(double[] arr) {
    if (arr == null) {
      return null ;
    }

    int len = arr.length ;
    for (int i = 0 ; i < len / 2 ; i++) {
      double tmp = arr[i] ;
      arr[i] = arr[len - i - 1] ;
      arr[len - i - 1] = tmp ;
    }

    return arr ;
  }

  /**
   * <zh>תеԪ.</zh>
   * <en>Reverse the array of elements.</en>
   *
   * @param arr int[] <zh>Ҫ (Ϊnull).</zh>
   * <en>To deal with the array (null permitted).</en>
   *
   * @return double[] <zh>תԪغ.</zh>
   * <en>After the reversal element of the array.</en>
   */
  public static int[] reverseArray(int[] arr) {
    if (arr == null) {
      return null ;
    }

    int len = arr.length ;
    for (int i = 0 ; i < len / 2 ; i++) {
      int tmp = arr[i] ;
      arr[i] = arr[len - i - 1] ;
      arr[len - i - 1] = tmp ;
    }

    return arr ;
  }

  /**
   * <zh>ۻٷֱ.</zh>
   * <en>Calculate the cumulative percent datas.</en>
   *
   * @param datas double[] <zh>Ҫ (Ϊnull).</zh>
   * <en>To deal with the array (null permitted).</en>
   * @return double[]
   */
  public static double[] calculateCumulativePercentData(double[] datas) {
    if (datas == null) {
      return null ;
    }

    double[] result = new double[datas.length] ;
    double total = 0.0 ;
    for (int i = 0 ; i < datas.length ; i++) {
      if (!Double.isNaN(datas[i])) {
        total += datas[i] ;
      }
    }

    if (total != 0.0) {
      double currTotal = 0.0 ;
      for (int i = 0 ; i < datas.length ; i++) {
        if (Double.isNaN(datas[i])) {
          result[i] = datas[i] ;
        } else {
          currTotal += datas[i] ;
          result[i] = currTotal / total ;
        }
      }
    }

    return result ;
  }

  /**
   * <zh>ۻٷֱ.</zh>
   * <en>Calculate the cumulative percent datas.</en>
   *
   * @param datas int[] <zh>Ҫ (Ϊnull).</zh>
   * <en>To deal with the array (null permitted).</en>
   * @return double[]
   */
  public static double[] calculateCumulativePercentData(int[] datas) {
    if (datas == null) {
      return null ;
    }

    double[] result = new double[datas.length] ;
    double total = 0.0 ;
    for (int i = 0 ; i < datas.length ; i++) {
      if (!Double.isNaN(datas[i])) {
        total += datas[i] ;
      }
    }

    if (total != 0.0) {
      double currTotal = 0.0 ;
      for (int i = 0 ; i < datas.length ; i++) {
        if (Double.isNaN(datas[i])) {
          result[i] = datas[i] ;
        } else {
          currTotal += datas[i] ;
          result[i] = currTotal / total ;
        }
      }
    }

    return result ;
  }

  /**
   * <zh>ٷֱ.</zh>
   * <en>Calculate the percent datas.</en>
   *
   * @param datas double[] <zh>Ҫ (Ϊnull).</zh>
   * <en>To deal with the array (null permitted).</en>
   * @return double[]
   */
  public static double[] calculatePercentData(double[] datas) {
    if (datas == null) {
      return null ;
    }

    double[] result = new double[datas.length] ;
    double total = 0.0 ;
    for (int i = 0 ; i < datas.length ; i++) {
      if (!Double.isNaN(datas[i])) {
        total += datas[i] ;
      }
    }

    if (total != 0.0) {
      for (int i = 0 ; i < datas.length ; i++) {
        if (Double.isNaN(datas[i])) {
          result[i] = datas[i] ;
        } else {
          result[i] = datas[i] / total ;
        }
      }
    }

    return result ;
  }

  /**
   * <zh>ٷֱ.</zh>
   * <en>Calculate the percent datas.</en>
   *
   * @param datas int[] <zh>Ҫ (Ϊnull).</zh>
   * <en>To deal with the array (null permitted).</en>
   * @return double[]
   */
  public static double[] calculatePercentData(int[] datas) {
    if (datas == null) {
      return null ;
    }

    double[] result = new double[datas.length] ;
    double total = 0.0 ;
    for (int i = 0 ; i < datas.length ; i++) {
      if (!Double.isNaN(datas[i])) {
        total += datas[i] ;
      }
    }

    if (total != 0.0) {
      for (int i = 0 ; i < datas.length ; i++) {
        if (Double.isNaN(datas[i])) {
          result[i] = datas[i] ;
        } else {
          result[i] = datas[i] / total ;
        }
      }
    }

    return result ;
  }

}
